<template>
  <crud-data-table
    :items="incomes"
    :headers="headers"
    :loading="isLoading"
    :search-placeholder="$t('global.crudDataTable.action.searchByTitlePlaceholder')"
    :no-data-message="$t('noDataText')"
    :overlay="!selectedPeriod"
    sort-by="title"
    show-expand
    @item-expanded="onItemExpanded"
  >
    <template v-slot:create>
      <create-income-dialog />
    </template>

    <template v-slot:confirmationToDelete>
      <delete-income-dialog @onDeleteIncome="onDeleteIncomeCallback = $event" />
    </template>

    <template v-slot:title="props">
      <edit-title-dialog
        v-model="props.item.title"
        :item-id="props.item.id"
      />
    </template>

    <template v-slot:amountsSum="{ item: { amountsSum } }">
      {{ amountsSum | formatCurrency | symbolWhenEmpty }}
    </template>

    <template v-slot:createdAt="{ item: { createdAt } }">
      {{ createdAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:updatedAt="{ item: { updatedAt } }">
      {{ updatedAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:delete="{ item }">
      <delete-icon-btn
        @click="onDeleteIncomeCallback(item)"
      />
    </template>

    <template v-slot:collapse="item">
      <amounts-table
        :income-id="item.id"
        :amounts="item.amounts"
      />
    </template>
  </crud-data-table>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import MoneyMixin from '@/mixins/money'
  import UtilsMixin from '@/mixins/utils'
  import getTableHeaders from './table-headers'
  import { get } from 'vuex-pathify'
  // components
  import EditTitleDialog from './components/crud/Update.vue'
  import DeleteIncomeDialog from './components/crud/Delete.vue'
  import CreateIncomeDialog from './components/crud/Create.vue'
  import AmountsTable from './components/amounts-table'

  export default {
    name: 'IncomesView',
    components: {
      EditTitleDialog,
      DeleteIncomeDialog,
      CreateIncomeDialog,
      AmountsTable,
    },
    mixins: [DatesMixin, MoneyMixin, UtilsMixin],
    data () {
      return {
        onDeleteIncomeCallback: null,
        headers: getTableHeaders(key => this.$t(key)),
      }
    },
    computed: {
      ...get('incomes', [
        'isLoading',
      ]),
      incomes () {
        return this.$store.getters['incomes/all']
      },
      selectedPeriod () {
        return this.$store.getters['periods/getSelectedPeriod']
      },
    },
    watch: {
      selectedPeriod: {
        handler () {
          this.loadIncomes()
        },
        deep: true,
      },
    },
    created () {
      this.loadIncomes()
    },
    methods: {
      loadIncomes () {
        this.$store.dispatch('incomes/getIncomes')
      },
      onItemExpanded ({ item, value: isOpen }) {
        if (isOpen) {
          this.$store.dispatch('incomeAmounts/getIncomeAmountsByIncomeId', {
            incomeId: item.id,
          })
        }
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          noDataText: 'Nenhuma receita cadastrada.',
        },
        'en-US': {
          noDataText: 'No incomes registered.',
        },
      },
    },
  }
</script>
